import {
  Component,
  OnInit,
  ViewChild } from '@angular/core';

import {
  IgxGridComponent,
  IGridCellEventArgs
} from "igniteui-angular";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
  @ViewChild("grid1", { read: IgxGridComponent, static: true })
  public grid1: IgxGridComponent;

  public data1 = [];

  counter = 0;

  public ngOnInit() {

    this.data1 = [
      {
        id: 25628,
        name: "Gawain Beadnall",
        email: "gbeadnall0@etsy.com",
        company: "Divanoodle",
        position: "Statistician I",
        referred_by: "Vyky Corwin",
      },
      {
        id: 86320,
        name: "Ivy Simkovich",
        email: "isimkovich1@clickbank.net",
        company: "Linktype",
        position: "Research Nurse",
        referred_by: "Hew Chung"
      },
      {
        id: 90552,
        name: "Rowen Titchen",
        email: "rtitchen2@netscape.com",
        company: "Meembee",
        position: "Staff Scientist",
        referred_by: "Web Ondrak"
      }
    ];


    setInterval(() => {
      this.data1 = [
        {
          id: 25628,
          name: "Gawain Beadnall" + this.counter++,
          email: "gbeadnall0@etsy.com",
          company: "Divanoodle",
          position: "Statistician I",
          referred_by: "Vyky Corwin",
        },
        {
          id: 86320,
          name: "Ivy Simkovich",
          email: "isimkovich1@clickbank.net",
          company: "Linktype",
          position: "Research Nurse",
          referred_by: "Hew Chung"
        },
        {
          id: 90552,
          name: "Rowen Titchen",
          email: "rtitchen2@netscape.com",
          company: "Meembee",
          position: "Staff Scientist",
          referred_by: "Web Ondrak"
        }
      ];
    }, 3000)
  }

  public gridData(dataItem) {
    const detailsData = [];
    let parentId = dataItem.id;

    for (let j = 0; j < 4; j++) {
      detailsData.push({
        Q: "Q" + (j + 1),
        test1: this.getRandomNumber(0, parentId),
        test2: this.getRandomNumber(0, parentId),
        test3: this.getRandomNumber(0, parentId)
      });
    }
    dataItem.gridData = detailsData;
    return dataItem.gridData;
  }

  public getRandomNumber(min: number, max: number): number {
    return Math.round(min + Math.random() * (max - min));
  }

  public onCellClick(evt: IGridCellEventArgs) {
    this.grid1.toggleRow(evt.cell.row.rowID);
	//this.grid1.gridAPI.set_row_expansion_state(evt.cell.row.rowID, true);
  }
}
